#ifndef __BACCH_LCREX_INCLUDE__
#define __BACCH_LCREX_INCLUDE__

// Wrapper for Volume Boost / LCRex generated by Matlab Coder

#include "BACCH_math.h"
#include "BACCH_buffer.h"
#include "BACCH_complex_buffer.h"
#include "BACCH_cx.h"
#include <stdlib.h>
//#include <string>


//==============================================================================
/**
*/
class BACCH_LCRex
{
public:
    //==============================================================================
    // Constructor
    // samplerate: audio samplerate
    // preset: which preset configuration to use
    BACCH_LCRex(int samplerate);

    // Destructor
    ~BACCH_LCRex();

    // process a frame of audio
    void process(BACCH_buffer* inbuffer, BACCH_buffer* outbuffer, BACCH_buffer* coutbuffer);

    // configure the LCRex instance:
    // load a new filter, clears internal buffers
    // input definition same as constructor
    // will cause discontinuity in output
    void configure(int samplerate);

    // Resets the internal state of the filter.
    // tail buffers are cleared.
    // This change happens immediately and will cause discontinuities in the output.
    void reset();

    // Clears the tail buffers.
    // This change happens immediately and might cause discontinuities in the
    // output.
    void clear(); 


private:

    BACCH_cx                *bcx;

    int                     mSampleRate;
	float					*pBuf;

	float                   *inChunk;
	float                   *outChunk;
	float                   *cChunk;

};

#endif //__BACCH_LCREX_INCLUDE__
